Bug 241321 - init.d script assumes bash is tomcat's login shell
init.d script assumes bash is tomcat's login shell
Product: Fedora
Classification: Fedora
Component: tomcat5 (Show other bugs)
All Linux
medium Severity high
: ---
: ---
Assigned To: Devrim GUNDUZ
Depends On:
  Show dependency treegraph
Reported: 2007-05-24 23:57 EDT by Dimitri Maziuk
Modified: 2008-05-06 15:37 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-05-06 15:37:23 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Dimitri Maziuk 2007-05-24 23:57:34 EDT
Description of problem:

It so happens we have a network login for tomcat user (running tomcat on
multiple machines) and its login shell is csh. Guess what happens when init
script does
"su - tomcat -c export $VAR=VAL ; export $VAR=VAL ; ... $TOMCAT_SCRIPT"

(If unsure, note the "su -" and look for "export" in csh manpage.)

Version-Release number of selected component (if applicable):

How reproducible:


Steps to Reproduce:
1. change login shell for tomcat user to csh
2. run /etc/init.d/tomcat5 start
Actual results:

tomcat doesn't start

Expected results:

it should start

Additional info:
Comment 1 Eric Ziegenhorn 2008-02-23 17:21:33 EST
I don't have the tomcat init script in front of me, but the tomcat startup
command could be made default shell-independent like this:

sudo su - tomcat -c "bash -c \"export VAR=VAL; export VAR2=VAL2; echo starting
tomcat command\""

But really, I question if this is even worthwhile.  I see no good reason for
using csh as tomcat's default shell, and many good reasons for not doing it
(such as this bug).  I'd prefer to just close this bug.
Comment 2 Dimitri Maziuk 2008-02-24 00:49:16 EST
As far as I'm concerned, nobody should csh for anything, but that's beside the
point. The point is, the command is not "shell independent", 'su - tomcat -c
"bash ..."', doesn't work.

'su tomcat -c "bash ..."', should, and "bash -l" might.

You don't know when someone su's to tomcat and messes with its login
environment. So why make daemon startup script dependent on things outside of
your control?
Comment 3 Bug Zapper 2008-04-04 03:17:17 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 4 Bug Zapper 2008-05-06 15:37:21 EDT
This bug is open for a Fedora version that is no longer maintained and
will not be fixed by Fedora. Therefore we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen thus bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.